function CreateGrid(obj,t)
% Function that creates a grid
% Version:  0.1 (13.03.2014)
% INPUT ARGUMENTS
% t:        Time index of Coords
% OUTPUT ARGUMENTS


%         obj.LatLines                    % Lax2 element vector with the list of
%                                         % (latitudes,color) of the lines
%         obj.LongLines                   % Lox2 element vector with the list of
%                                         % (longitudes,color) of the lines
%         obj.GridGeoCoords
%         obj.GridCoords                  % {t}(Index,Color)

% -------------------------------------------------------------
% Initialization
% -------------------------------------------------------------
if isempty(obj.LatLines)
    SetDefaultGrid(obj);
end;
    
% -------------------------------------------------------------
% Initialization
% -------------------------------------------------------------
obj.GeoTables
    
        DeltaLat                    % Vector with the diferent latitudes to be analyzed
        DeltaLong                   % Vector with the different longitudes to be analyzed
        GeoCoordsTable              % {t}[DeltaLat samples,DeltaLong samples,3]
                                    % where the third dimension contains 
                                    % [mean_h, mean_R, LinkTable index]
        LinkTable                   % nx2 table with [(Geo)Coords index,GeoCoordsTable Index]    
    
% -------------------------------------------------------------
% Latitude Lines
% -------------------------------------------------------------
k = 0;
N = size(obj.GeoCoordsTable,2);
for ii = 1:size(obj.LatLines,1)
    [~,DLat] = min(abs(DeltaLat - obj.LatLines(ii,1)));
    for jj = 1:N

        % Search for all points in the main object
        Indexes = obj.LinkTable(:,2) == obj.GeoCoordsTable{t}(DLat,jj,3);
        % Chose the one with the highest height
        [~,CI] = max(obj.GeoCoords{t}(Indexes,3));
        % Add Point to the grid
        k = k + 1;
        obj.GridCoords{t}(k,1) = CI;
        obj.GridCoords{t}(k,1) = obj.LatLines(ii,2);
        % QUE HAGO CON LOS PUNTOS CRUCE???
    end;
    
end;
    
    
% -------------------------------------------------------------
% Longitude Lines
% -------------------------------------------------------------
% for ii = 1:size(obj.LongLines,1)
%     
%     
%     
%     
% end;


% -------------------------------------------------------------
% Add grid to main object
% -------------------------------------------------------------



% -------------------------------------------------------------
% Add grid to map
% -------------------------------------------------------------


end


function SetDefaultGrid(obj)
% Function that creates a grid
% Version:  0.1 (13.03.2014)
% -------------------------------------------------------------
% Latitude lines
% -------------------------------------------------------------
Lines = (-90:10:90)';
L = length(Lines)-1;
Color = (0:L)/L * 100 + 100;
obj.LatLines = [Lines,Color];
% -------------------------------------------------------------
% Longitude lines
% -------------------------------------------------------------
Lines = (-180:10:180)';
L = length(Lines)-1;
Color = (0:L)/L * 100 + 100;
obj.LongLines = [Lines,Color];

end




