function [M] = LinePoints(M,Rows,Cols,Value)
% List of points to form a line between two points
%
% Version:  0.1 (08.04.2014)
%
% INPUT ARGUMENTS
% M:            Input matrix
% Rows:         nx1 vector with the pixel row coordinates of the points
% Cols:         nx1 vector with the pixel column coordinates of the points
% Value:        Value for the points (Default = 1)
% OUTPUT ARGUMENTS
% M:            Updated matrix
% -------------------------------------------------------------------------
% Initialization
% -------------------------------------------------------------------------
if nargin < 3
    Value = 1;
end;

% -------------------------------------------------------------------------
% Initialization
% -------------------------------------------------------------------------
MSize = size(M);
for n = 2:length(Rows)
    K = max(abs([Rows(n)-Rows(n-1),Cols(n)-Cols(n-1)]));
    Idx = sub2ind(MSize,round(linspace(Rows(n-1),Rows(n),K)),round(linspace(Cols(n-1),Cols(n),K)));
    M(Idx) = Value;
end;
    

