function [Indexes] = LinePointsIndexes(MSize,Rows,Cols)
% List of points to form a line between two points
%
% Version:  0.1 (08.04.2014)
%
% INPUT ARGUMENTS
% MSize:        Matrix Size
% Rows:         nx1 vector with the pixel row coordinates of the points
% Cols:         nx1 vector with the pixel column coordinates of the points
% Value:        Value for the points (Default = 1)
% OUTPUT ARGUMENTS
% Indexes:      Indexed positions
% -------------------------------------------------------------------------
% Initialization
% -------------------------------------------------------------------------

% -------------------------------------------------------------------------
% Initialization
% -------------------------------------------------------------------------
K = round(3*max([max(Rows)-min(Rows),max(Cols)-min(Cols)]));
Indexes0 = zeros(K,1,'uint32');

ii = 0;
for n = 2:length(Rows)
    K = ceil(max(abs([Rows(n)-Rows(n-1),Cols(n)-Cols(n-1)])))+1;
    Idx = sub2ind(MSize,round(linspace(Rows(n-1),Rows(n),K)),round(linspace(Cols(n-1),Cols(n),K)));
    Indexes0(ii+1:ii+length(Idx)) = Idx;
    ii = ii + length(Idx);
end;
Indexes = Indexes0(1:ii);
    

