%% Load of images

File = 'D:\Matlab-Hernan\SurfMap Examples\Cell moving bleach\ER tdEos\ER tdEos - enhanced-Gaussian.tif';

S = readTiff5D(File,'xyzct');

%% Registration

S2 = zeros(size(S),class(S));
TransformType = 'rigid';
[Optimizer, Metric] = imregconfig('monomodal');

RefChannel = 2;

StackSize = size(S);

RefCoordSys = imref3d(StackSize(1:3));

S2(:,:,:,:,size(S,5)) = S(:,:,:,:,size(S,5));
for t = size(S,5)-1:-1:1
    disp(num2str(t));
%     S2(:,:,:,c,t-1) = imregister(S(:,:,:,1,t),S(:,:,:,1,t-1),TransformType,Optimizer,Metric);
    % Estimate transformation
    TForm = imregtform(S(:,:,:,RefChannel,t),S2(:,:,:,RefChannel,t+1),TransformType,Optimizer,Metric);
    % Apply transformation to each channel
    for c = 1:StackSize(4)
        S2(:,:,:,c,t) = imwarp(S(:,:,:,c,t),TForm,'linear','OutputView',RefCoordSys);
    end;
end;

%%

[Pathname,Filename,Fileext] = fileparts(File);

Filename = [Filename,'__RegLin'];
File2 = fullfile(Pathname,[Filename,'.btf']);

writeBigTiff5D(File2,S2,'xyzct');


