%% Load of images

File = '';   % Write Path and filename

S = readTiff5D(File,'xyzct');

%% Registration

S2 = zeros(size(S),'like',S);
TransformType = 'translation';%'rigid';
[Optimizer, Metric] = imregconfig('monomodal');

RefChannel = 1;

StackSize = size(S);

RefCoordSys = imref3d(StackSize(1:3));

for t = 2:size(S,5)
    disp(num2str(t));
    % Estimate transformation
    S2(:,:,:,:,1) = S(:,:,:,:,1);
    TForm = imregtform(S(:,:,:,RefChannel,t),S2(:,:,:,RefChannel,t-1),TransformType,Optimizer,Metric);
    % Apply transformation to each channel
    for c = 1:StackSize(4)
        S2(:,:,:,c,t) = imwarp(S(:,:,:,c,t),TForm,'linear','OutputView',RefCoordSys);
    end;
end;

%%

[Pathname,Filename,Fileext] = fileparts(File);

Filename = [Filename,'__linear'];
File2 = fullfile(Pathname,[Filename,'.btf']);

writeBigTiff5D(File2,S2,'xyzct');


