classdef SurfaceMap < Figure5D 
    % SURFACEMAP class contained a the information of a 2D surface map and 
    % its connection to the original 3D-5D to object surface
    %   Detailed explanation goes here

    % Version:  0.7.0 (01.11.2014) Duplicate map
    %           0.3.0 (16.08.2013) Now with extra stack and mask
    %                              Little correction to the overlap algorithm
    %           0.2.3 (27.06.2013) New object structure based on sm_stack2xyz
    %           0.2.1 (24.06.2013) New SurfData3D structure
    %                            Channel is ignored in SBin (use only 1)
    %                            Optimization for higher speed
    %                            SurfData3D output
    %           0.06 (17.06.2013) Fixed Bug
    %           0.05 (14.06.2013) Binary and Real 4D and 5D stack support
    %           0.04 (13.06.2013) 5D stack support for both SBin and SReal
    %           0.03 (21.05.2013) Add SurfData.DataClass
    %           0.02 (16.05.2013) Add SReal and SurfData structure
    %           0.01 (06.05.2013)
    %    
    
    
    properties
        
        NextUpdate = 0;
        
        PrefixName = '';
        VirtualStack = false;
        
                                    
    end
    
    methods (Abstract=true)
        
%         UpdateMap(obj,n)
        PropertiesDialog(~,~,obj,Flag);
%         M = Parent2Child(obj,L,T);
            % Convert Parent Coords to Child Coords (MapCoords)
            % INPUT ARGUMENTS
            % L:            List of Coords indexes (Map32D.Coords)
            % T:            Time value
            % OUTPUT ARGUMENTS
            % M:            List of Coords indexes (SurfaceMap.MapCoords)
            % -------------------------------------------------------------
%         M = Child2Parent(obj,Lclo,T);
            % Convert Child Coords to Parent Coords (MapCoords)
            % INPUT ARGUMENTS
            % L:            List of Coords indexes (SurfaceMap.MapCoords)
            % T:            Time value
            % OUTPUT ARGUMENTS
            % M:            List of Coords indexes (Map32D.Coords)
            % -------------------------------------------------------------        
        
        DuplicateMap(~,~,obj);
            
    end;
    
    methods
        function obj = SurfaceMap(MainObjectHandle,varargin)
            obj = obj@Figure5D([],'LogHistory',MainObjectHandle.LogHistory,varargin{:});
            % Update objects cross-references
            obj.ParentImage = MainObjectHandle;
            MapIndex = length(MainObjectHandle.ChildImages)+1;
            MainObjectHandle.ChildImages{MapIndex} = obj;
            % Update Folder
            obj.Folder = obj.ParentImage.ProjectFolder;
            obj.LogHistory = obj.ParentImage.LogHistory;
        end;

        % =================================================================        

%         function CreateMenubar(obj,MenuStruct)
%             % Create MenuBar
%             % INPUT ARGUMENTS
%             % MenuStruct:     Optional base Menubar (not really used)
%             % -------------------------------------------------------------
%             if nargin < 2
%                 MenuStruct = [];
%             end;
%             if isempty(MenuStruct)
%                 % Define standard menubar
%                 MenuStruct = obj.DefineMenubar;
%             end;
%             % -------------------------------------------------------------
%             % Add Map menu
%             % -------------------------------------------------------------
%             MenuStruct.Callback{4}.Label{end+1} = 'Map properties';
%             MenuStruct.Callback{4}.Separator(end+1) = 1;
%             MenuStruct.Callback{4}.Enable(end+1) = 1;
%             MenuStruct.Callback{4}.hMenu(end+1) = 0;
%             MenuStruct.Callback{4}.Callback{end+1} = {@PropertiesDialog,obj,1};
%             % -------------------------------------------------------------
%             % Superclass CreateMenubar
%             % -------------------------------------------------------------
%             CreateMenubar@Figure5D(obj,MenuStruct);
%         end;

        
%         % =================================================================
%         % Properties set/get functions (validation)
%         % -----------------------------------------------------------------        

        
        % =================================================================        
            
        function RoiManager_Transfer(obj)
            if ~isempty(obj.ParentImage) && obj.NextUpdate > 0
                msgbox({'The original stack masks have changed...'...
                    ;'You need to update the map (by applying properties) before transfering anything information'}...
                    ,'Error','error','modal');
                return
            end
            RoiManager_Transfer@Figure5D(obj); 
        end
        
        % =================================================================        
            
    end
    
end

