function SE = strel3D(Option,Size)
% Perform 3D morphology operations on binary images
%
% INPUT ARGUMENTS:
% I:                3D binary matrix
% Operation:        Possibilities:
%                       'erode'
%                       'dilate'
%                       'open'
%                       'close'
% SEOption:         Possibilities:
%                       'cube'
%                       'ball'
% SESize:           [rows,cols,height]  (should be odds)


switch Option
    case 'cube'
        SE = true(Size);
    case 'ball'
%         SE = zeros(SESize);
        Center = floor((Size+1)./2);
        SemiAxis = (Size - Center).^2;
        [XX,YY,ZZ] = ndgrid(1:Size(1),1:Size(2),1:Size(3));
        SE = ((XX-Center(1)).^2)/SemiAxis(1)+((YY-Center(2)).^2)/SemiAxis(2)+((ZZ-Center(3)).^2)/SemiAxis(3) <= 1;
end;








